# -*- coding: latin-1 -*-
import threading
#from wxPython.wx import *
#import CsoundVST importeres i happysound.py


class CsoundKontroll:
    def __init__(self,csound,spill):
        self.csound = csound
        # Oppretter CSound trden og starter den
        if spill:
            self.csoundThread = threading.Thread(None, self.csoundThreadRoutine)
            #self.csoundThread.setDaemonic(1)
            self.csoundThread.start()
        else:
            self.erInit = False
        # Initialiserer Csound og starter utfrelsen i en separat trd
        # Csound spiller av noter som blir sendt fra Musikkmaker

    def setinstr1(self):
            self.csound.setOrchestra('''
            sr=22050
            kr=2205
            ksmps=10
            nchnls=1
                instr   1
                ; Konverterer MIDI key-number(fra Musikkmaker) til oktaver
                ioctave = p4 / 12.0 + 3.0
                ; Konverterer oktav til frekvens
                ihertz = cpsoct(ioctave)
            a1  oscili  ampdb(p5), ihertz, 1
                kenv linseg 0, p3/4, 1, p3/2, 0.8, p3/4, 0
                a1 = kenv * a1
                out    a1
                endin
            ''')
            self.csound.setScore('''
            f1 0 8192 10 1
            e
            ''')
            
    def setinstr2(self):
            # Setter instrumenter
            self.csound.setOrchestra('''
            sr = 22050
            kr = 2205
            ksmps = 10
            nchnls = 1

        ; Gitar1
        instr   1
            iamp    =   32767*p4
            ifn =   p6
            imeth   =   p7
            ;ifreq  =   cpspch(p5)
            ioctave =   p5 / 12.0 + 3.0
            ifreq   =       cpsoct(ioctave)
            icps    =       (p10 == 0 ? ifreq : cpspch(p10))
            asig    pluck   iamp,ifreq,icps,ifn,imeth
            asig    linen   asig,.001,p3,.1     ;final envelope
                out     asig
        endin

        ; Gitar2
        instr   2
            imaxamp =   32767
            ioctave =   p5 / 12.0 + 3.0
            ifreq   =       cpsoct(ioctave)
            kenv    line    imaxamp*p4, p3, 0
            awave   oscil   kenv, ifreq, 2
                out awave
        endin

        ; Gitar med vibrato
        instr   3 ; same thing, with vibrato capability
            ioctave =   p5 / 12.0 + 3.0
            ifreq   =       cpsoct(ioctave)
            imaxamp =   32767
            kenv    line    imaxamp*p4, p3, 0
            kvib    linseg  0, p3/2, ifreq*0.02, p3/2, 0
            avib    oscil   kvib, 6, 2 ; vibrato oscillator
            awave   oscil   kenv, ifreq+avib, 3
                out awave
        endin

        instr 21; hihat

          ilen init p3
          iamp init p4

          kcutfreq  expon     10000, 0.1, 2500
          aamp      expon     iamp,  0.1,   10
          arand     rand      aamp
          alp1      butterlp  arand,kcutfreq
          alp2      butterlp  alp1,kcutfreq
          ahp1      butterhp  alp2,3500
          asigpre   butterhp  ahp1,3500
          asig      linen    (asigpre+arand/2),0,ilen, .05  

          out asig
        endin

        instr 22; snare
          icps0  = 147
          iamp   = p4*0.7

          icps1  =  2.0 * icps0

          kcps   port icps0, 0.007, icps1
          kcpsx  =  kcps * 1.5

          kfmd   port   0.0, 0.01, 0.7
          aenv1  expon  1.0, 0.03, 0.5
          kenv2  port   1.0, 0.008, 0.0
          aenv2  interp kenv2
          aenv3  expon  1.0, 0.025, 0.5

          a_     oscili 1.0, kcps, 1
          a1     oscili 1.0, kcps * (1.0 + a_*kfmd), 1
          a_     oscili 1.0, kcpsx, 1
          a2     oscili 1.0, kcpsx * (1.0 + a_*kfmd), 1

          a3     unirand 2.0
          a3     =  a3 - 1.0
          a3     butterbp a3, 5000, 7500
          a3     =  a3 * aenv2

          a0     =  a1 + a2*aenv3 + a3*1.0
          a0     =  a0 * aenv1

          out a0*iamp
        endin


        instr 23; kick
          iamp      = p4

          k1  expon    120, .2, 50    
          k2  expon    500, .4, 200
          a1  oscil    iamp, k1, 1
          a2  reson    a1, k2, 50
          a3  butterlp  a2+a1,k1,1
          a4  butterlp  a3,   k1,1
          a5  butterlp  a4,2500,1
          a6  butterhp  a5,50
          a7  butterhp  a6,50
          a8  linen    a7,0.01,p3, .2  

          out a8
        endin
        
        instr 25; Klapp
          iamp     = p4
          
          kamp1 expon 1.25, .03,  .0001
          kamp2 expseg .001,.005,1, .35, .001
          
          anoise rand 1
        
          anoise1 = anoise*kamp1
          anoise2 = anoise*kamp2
          
          adel1     = anoise1
          adel2 delay anoise1, .01
          adel3 delay anoise1, .02
        
          adel4 delay anoise2, .03
          
          abp1 resonz adel1,  400,  1100
          abp2 resonz adel2,  600,  1100
          abp3 resonz adel3,  800,  1100
          abp4 resonz adel4,  1100, 1100
          
          out iamp*2*(abp1+abp2+abp3+abp4)
        endin


            ''')
            self.csound.setScore('''
        ; Square Wave
        f   1       0       512     10      1   0   .3   0   .2    0  .14    0 .111
        f   2   0   1024    10  1 ; sine wave (for vibrato)
        f   3   0   512 1   "gtr512.aiff"   0   0   0 ; uses the first 512 samples of the file

        ;p7=1... simple averaging, use noise source (ifn = 0)
        ;                       amp     pitch   ifn     imeth   iparm1  iparm2
        ;i1      0       1       20000   7.05    0       1
        ;i1      .5      .       .       8.03
        ;i1      1       .       .       9.01
        ;f0      2.5
            e
            ''')


    def csoundThreadRoutine(self):

            self.setinstr2()
            
            # Setter Csound til  gi Real-time output.
            self.csound.setCommand('''csound -d -m0 -b128 -B2048 -odac1 temp.orc temp.sco''')
            # Eksporterer orkesteret og partituret
            self.csound.exportForPerformance()
            # Starter utfrelsen
            self.csound.compile()
            # Utfr i blokker av ksmps
            self.perform = True
            while self.perform:
                self.csound.performKsmps(True)
                #if self.csound.PerformKsmps():
                #    print 'Performance finished.'
                #    return

    def avslutt(self):
        try:
            print "Avslutter CSound traaden"
            self.csound.Stop()
            self.perform = False
            self.csoundThread.join()
            self.csound.Cleanup()
            self.csound.Reset()
            print 'Csound thread has finished.'
        except:
            print 'Err..'
