# -*- coding: latin-1 -*-

from time import localtime,strftime
from tkSnack import *
from Tkinter import *
from NNdef  import *

class NNFrame:
    """ Rammen som inneholder alle de grafiske elementene """
    def __init__(self, master,csound):
    	""" Oppretter applikasjonsvinduet og setter alle elementer"""
        print strftime("%H:%M:%S", localtime()),': Start'
        self.csound = csound
        self.musmak = Musikkmaker.Musikkmaker(self.csound)
        self.fs = 16000
        self.id = 0
        self.wait = 400 # tid mellom kjringer av rec eller draw
        self.p0 = 0
        self.sLength = 0
        self.lastet = False
        self.fftl = 512
        self.fqmin = 2
        self.fqmax = 128
        self.nnlen = 126
        self.forrigedur = [0,0,0,0]
        self.sound = Sound()
        master.geometry('800x600')
        self.toplevel = master
        self.toplevel.title('NNtune')
        self.toplevel.iconname('NNtune')
        

        # Knapper i bunn
        self.bottomFrame = Frame(self.toplevel)
        self.bottomFrame.pack(side=BOTTOM, pady=5, padx=5, fill=X )     


        # Hyre Frame
        self.hFrame = Frame(self.toplevel)
        self.hFrame.pack(side=RIGHT,fill=BOTH,padx=10)
        self.initHappyBtn = Button(self.hFrame, text='Initier Happysound', command=self.initHappy)
        self.initHappyBtn.pack(side='top',fill=X)
        self.laglyd = IntVar()
        cb = Checkbutton(self.hFrame, text="Init CSound", variable=self.laglyd)
        cb.pack()
        cb.select()
        mmFrame = Frame(self.hFrame)
        mmFrame.pack(side=TOP,fill=X,pady=30)        
        self.startHappyBtn = Button(mmFrame, text='Start', fg='red', command=self.startHappy, state=DISABLED)
        self.startHappyBtn.pack(side=LEFT,padx=10)        
        self.stopHappyBtn = Button(mmFrame, text='Stopp', fg='blue', command=self.stoppHappy, state=NORMAL)
        self.stopHappyBtn.pack(side=RIGHT,padx=10)
               
        durvFrame = Frame(self.hFrame)
        durvFrame.pack(side=TOP,fill=X,pady=10)        
        self.durValg = IntVar()
        r1 = Radiobutton(durvFrame, text="Dur", variable=self.durValg, value=1, command=self.seldur)
        r1.pack(side=TOP)
        Radiobutton(durvFrame, text="Moll", variable=self.durValg, value=2, command=self.seldur).pack(side=TOP)
        Radiobutton(durvFrame, text="Blues", variable=self.durValg, value=3, command=self.seldur).pack(side=TOP)
        r1.select()
        self.s1 = Scale(self.hFrame,label="Startnote",orient=HORIZONTAL,command=self.selStartN, to=127)
        self.s1.pack()
        self.s1.set(60)
        self.s2 = Scale(self.hFrame,label="Glad verdi",orient=HORIZONTAL,command=self.selStartG)
        self.s2.pack()
        self.s2.set(75)
        self.s3=Scale(self.hFrame,label="Rolig verdi",orient=HORIZONTAL,command=self.selStartR)
        self.s3.pack()
        self.s3.set(30)
        self.s4=Scale(self.hFrame,label="Tempo",orient=HORIZONTAL,command=self.selStartT, to=200,resolution=10)
        self.s4.pack()
        self.s4.set(120)



        # Topp Frame
        self.topFrame = Frame(self.toplevel)
        self.topFrame.pack(side=TOP, padx=5, fill=X)
        self.topFrame.pack()
        self.c  = SnackCanvas(self.topFrame, height=200, width=600, bg='white', relief='sunken', bd=1)
        self.cid = self.c.create_waveform (0, 0, sound=self.sound, height=200, width=600)
        self.c.pack ()

        
        
        #Middle Frame
        self.middleFrame = Frame(self.toplevel)
        self.middleFrame.pack(fill=Y,expand=YES)
        self.mlFrame = Frame(self.middleFrame)
        self.mlFrame.pack(side=LEFT,fill=BOTH)
        self.mltFrame = Frame(self.mlFrame)
        self.mltFrame.pack(side=TOP,pady=5,fill=BOTH)
        self.mlcFrame = Frame(self.mlFrame)
        self.mlcFrame.pack(pady=5,fill=BOTH)
        self.mlbFrame = Frame(self.mlFrame)
        self.mlbFrame.pack(pady=5,fill=BOTH)
        self.mlb2Frame = Frame(self.mlFrame)
        self.mlb2Frame.pack(side=BOTTOM,pady=5)
        self.mrFrame = Frame(self.middleFrame)
        self.mrFrame.pack(side=RIGHT,fill=BOTH)
        
        #MR
        self.c2 = SnackCanvas(self.mrFrame, height=200, width=300, bg='white', relief='sunken', bd=1)
        self.cid2 = self.c2.create_section    (0, 0, sound=self.sound, height=200, width=300)
        self.c2.pack()
        bbar = Frame(self.mrFrame)
        bbar.pack(side='bottom')
        self.tsEntry = Entry(bbar,background = 'white',width=5)
        self.tsEntry.insert(INSERT, "0.15") 
        self.tsEntry.pack(side=LEFT)
        Button(bbar, bitmap='snackRecord', fg='blue', command=self.startLive).pack(side='left')
        Button(bbar, bitmap='snackStop', command=self.stop).pack(side='left')
        bbar2 = Frame(self.mrFrame)
        bbar2.pack(side='bottom',pady=5)
        self.akkEntry = Entry(bbar2,background = 'white',width=5)
        self.akkEntry.insert(INSERT, "a") 
        self.akkEntry.pack(side=LEFT)
        Button(bbar2, text='Ta opp akkord', fg='red', command=self.startRec).pack(side='left')
        self.wEntry = Entry(self.mrFrame,background = 'white',width=5)
        self.wEntry.insert(INSERT, "400") 
        Label(self.mrFrame,text="Rec intervall").pack(side=TOP)
        self.wEntry.pack(side=TOP)

        #HML
        ffbar = Frame(self.mltFrame)
        ffbar.pack(side=TOP)
        ffbar2 = Frame(self.mltFrame)
        ffbar2.pack(side=TOP)
        Label(ffbar,text="FFT len", width=6).pack(side=LEFT)
        Label(ffbar,text="Min freq", width=6).pack(side=LEFT)
        Label(ffbar,text="Max freq", width=6).pack(side=LEFT)
        self.FFtEntry = Entry(ffbar2,background = 'white', width=6)
        self.FFtEntry.insert(INSERT, "512") 
        self.FFtEntry.pack(side=LEFT)
        self.fqminEntry = Entry(ffbar2,background = 'white', width=6)
        self.fqminEntry.insert(INSERT, "80") 
        self.fqminEntry.pack(side=LEFT)
        self.fqmaxEntry = Entry(ffbar2,background = 'white', width=6)
        self.fqmaxEntry.insert(INSERT, "3990") 
        self.fqmaxEntry.pack(side=LEFT)
        Button(self.mltFrame, text='Set FFT',     command=self.setFFT, width=10).pack()
        Label(self.mltFrame,text="NN inn-skjulte-ut").pack(side=TOP)
        self.NNiEntry = Entry(self.mltFrame,background = 'white',width=5)
        self.NNiEntry.insert(INSERT, "126") 
        self.NNiEntry.pack(side=LEFT)
        self.NNhEntry = Entry(self.mltFrame,background = 'white',width=5)
        self.NNhEntry.insert(INSERT, "32") 
        self.NNhEntry.pack(side=LEFT)
        self.NNuEntry = Entry(self.mltFrame,background = 'white',width=5)
        self.NNuEntry.insert(INSERT, "4") 
        self.NNuEntry.pack(side=LEFT)
        Button(self.mlcFrame, text='Opprett NN',     command=self.opprettNN, width=10).pack()

        self.fileFrame = Frame(self.middleFrame)
        self.fileFrame.pack(side=TOP, fill=BOTH)
        self.filesBar = Scrollbar(self.fileFrame)
        self.filesBar.pack(side=RIGHT)
        self.fileList = Listbox(self.fileFrame,background = 'white',exportselection=0,height=10,width=40,
                     yscrollcommand=(self.filesBar, 'set'))
        self.filesBar.configure(command = self.fileList.yview)
        Label(self.fileFrame,text="NN fra fil").pack(side='top')
        self.fileList.pack(side=TOP)
        for item in finnSaved():
            self.fileList.insert(END, item)
        self.fileList.select_set(0)
        Button(self.fileFrame,  text='Last in NN',  command=self.lastInn,   width=10).pack( side=TOP, pady=5)
        Button(self.fileFrame,  text='Last in kun Pat',  command=self.lastInnPat, width=20).pack( side=TOP, pady=0)

        self.NNsaveEntry = Entry(self.mlbFrame,background = 'white',width=30)
        self.NNsaveEntry.insert(INSERT, "(512).nnt") 
        self.NNsaveEntry.pack()
        Button(self.mlbFrame,  text='Lagre NN',    command=self.saveData,  width=10).pack( side=BOTTOM)

        Button(self.mlb2Frame,  text='Test akks i dir',    command=self.testDir,  width=10).pack( side=TOP)

        
        self.labelFrame = Frame(self.mlb2Frame)
        self.labelFrame.pack(side=TOP, fill=X)
        self.entFrame = Frame(self.mlb2Frame)
        self.entFrame.pack(side=TOP, fill=X)
        Label(self.labelFrame,text="Iter.", width=6).pack(side=LEFT)
        self.itEntry = Entry(self.entFrame,background = 'white', width=6)
        self.itEntry.insert(INSERT, "1000") 
        self.itEntry.pack(side=LEFT)
        Label(self.labelFrame,text="MinErr", width=6).pack(side=LEFT)
        self.minerrEntry = Entry(self.entFrame,background = 'white',width=5)
        self.minerrEntry .insert(INSERT, "0") 
        self.minerrEntry .pack(side=LEFT)
        Button(self.mlb2Frame, text='Tren NN',    command=self.tren,  width=10).pack()


        #Start applikasjonen
        self.csKontroll = False
        self.toplevel.mainloop()
        self.musmak.avslutt = True
        if self.csKontroll:
            self.csKontroll.avslutt()
        print strftime("%H:%M:%S", localtime()),': Avsluttet Happysound'
        

    def initHappy(self):
        print 'Initierer Happy'
        self.c.delete(self.cid)
        self.c2.delete(self.cid2)
        self.initHappyBtn.config(state = DISABLED)
        self.startHappyBtn.config(state = NORMAL)
        self.csKontroll = CsoundKontroll.CsoundKontroll(self.csound,self.laglyd.get())
        self.musmak.spill = self.laglyd.get()
        self.musmak.start()


    def startHappy(self):
        print 'Starter happy'
        self.startHappyBtn.config(state = DISABLED)
        self.musmak.lagmusikk = True

    def stoppHappy(self):
        print 'Stopper happy'
        self.startHappyBtn.config(state = NORMAL)
        self.musmak.stopp()
        self.musmak.nullstill()
        self.musmak.initval()
        self.s1.set(60)
        self.s2.set(75)
        self.s3.set(30)
        self.s4.set(120)

    def seldur(self):
        if self.durValg.get()==1:
            self.musmak.skalaibruk = self.musmak.dur
            print 'Setter skala til dur'
        elif self.durValg.get()==2:
            self.musmak.skalaibruk = self.musmak.moll
            print 'Setter skala til moll'
        elif self.durValg.get()==3:
            self.musmak.skalaibruk = self.musmak.blues
            print 'Setter skala til blues'


    def selStartN(self,val):
        self.musmak.noten = int(val)
        print 'setter noten til', val

    def selStartG(self,val):
        self.musmak.glad = int(val)
        print 'setter glad til', val

    def selStartR(self,val):
        self.musmak.rolig = int(val)
        print 'setter rolig til', val

    def selStartT(self,val):
        self.musmak.tempo = int(val)
        print 'setter tempo til', val

    def tren(self):
        tren(self.nn,it=int(self.itEntry.get()),minerr=float(self.minerrEntry.get()))
    
    def opprettNN(self):
        self.nn = opprett(ni=int(self.NNiEntry.get()),nh=int(self.NNhEntry.get()), nu=int(self.NNuEntry.get()))
        self.lastet = True

    def testDir(self):
        finnDir(self.nn,'akks',fft=self.fftl,fqs=self.fqmin,fqe=self.fqmax)

    def setFFT(self):
        self.fftl = int(self.FFtEntry.get()) 
        hzprb = (self.fs/2)/(self.fftl/2)
        self.fqmin = int(self.fqminEntry.get())/hzprb
        self.fqmax = int(self.fqmaxEntry.get())/hzprb
        self.nnlen = self.fqmax-self.fqmin
        self.NNiEntry.delete(0,END)
        self.NNiEntry.insert(INSERT, self.nnlen)
        print 'setter fftlen=',self.fftl,'og nnlen=',self.nnlen
        print self.fqmin, self.fqmax
    
    def lastInn(self):
    	"""Laste inn nettverk fra fil"""
        self.nn, exI = restoreData(fil=self.fileList.get(self.fileList.curselection()[0]))
        if exI != 0:
            self.fftl = exI[0]
            self.FFtEntry.delete(0,END)
            self.FFtEntry.insert(INSERT, self.fftl)
            hzprb = (self.fs/2)/(self.fftl/2)
            self.fqmin = exI[1]
            self.fqminEntry.delete(0,END)
            self.fqminEntry.insert(INSERT, self.fqmin*hzprb)
            self.fqmax = exI[2]
            self.fqmaxEntry.delete(0,END)
            self.fqmaxEntry.insert(INSERT, self.fqmax*hzprb)
        
        self.lastet = True
        self.nnlen = self.nn.ni-1
        self.NNiEntry.delete(0,END)
        self.NNiEntry.insert(INSERT, self.nnlen)
        print 'Nettverk:',self.nn.ni-1,self.nn.nh,self.nn.no,'exI',exI
        
    def lastInnPat(self):
        self.pat1 = restoreDataPat(fil=self.fileList.get(self.fileList.curselection()[0]))

    def saveData(self):
        saveData(self.nn,fil=self.NNsaveEntry.get(),exI=[self.fftl,self.fqmin,self.fqmax])

    def stop(self):
        print strftime("%H:%M:%S", localtime()), 'stop'
        self.sound.stop()        
        self.toplevel.after_cancel(self.id)
        if self.csKontroll:
            self.musmak.lagmusikk = False

    def startLive(self):
    	""" starter opp draw metoden"""
        print strftime("%H:%M:%S", localtime()), 'start live'
        self.wait = int(self.wEntry.get())
        self.p0 = 0
        self.sLength = 0
        if not(self.lastet):
            print 'Ingen nettverk lastet'
            return
        self.sound.record()
        self.id = self.toplevel.after(self.wait,self.draw)

    def startRec(self):
    	"""Starter opp rec metoden"""
        self.wait = int(self.wEntry.get())
        print strftime("%H:%M:%S", localtime()), 'start rec, int:',self.wait
        self.p0 = 0
        self.sLength = 0
        self.sound.record()
        self.id = self.toplevel.after(self.wait,self.rec)

    def rec(self):
    	""" Metode for  registrere akkorder i treningssettet
    	Metoden kjrer i 10 sekunder og registrerer ny akkord 
    	ved hvert rec-intervall"""
        spec = self.getspec()
        if (spec != -1): 
            pat1.append([ spec,akklist[self.akkEntry.get()] ])
            print 'la til en akk i pat1:', len(pat1),self.akkEntry.get()
        if (self.sound.length(unit='sec') > 10) :
            self.sound.stop()
        else:
            self.id = self.toplevel.after(self.wait,self.rec)
   
    def draw(self):
        """ Metoden som viser hvilken akkord som blir spilt. 
        Henter specter fra avspilt akkord via
        getspec metoden og tester disse verdiene i nettverket.
        Metoden gjentar seg selv etter self.wait millisekund  """
        
        self.id = self.toplevel.after(self.wait,self.draw)
        spec = self.getspec()
        terskel = self.tsEntry.get()
        if (spec != -1): 
            erval = self.nn.finnValE(spec)
            #if erval[1]<0.15 and erval[0] != self.forrigedur:
            if erval[1]<terskel and erval[0] != self.forrigedur:
                akk = finnAkk(erval[0])
                note = finnMidiN(akk)
                dur = finnDur(akk)
                print self.musmak.spilltick, akk,round(erval[1],2),"---",dur,note
                if self.csKontroll:
                    self.musmak.settNote(note,dur)
                self.forrigedur = erval[0]

    def finnmax(self):
        """Returnerer posisjonen til samplet med hyest verdi
        Metoden leter i siste avspilte intervall"""
        self.p0 = self.sLength
        self.sLength = self.sound.length() - int(0.2*self.fs) -1
        if self.sLength<0:
            self.sLength = 0
        #print 'slen  ',int(self.sLength*1000/self.fs)
        max = self.sound.max(start=self.p0, end=self.sLength)
        if(max<5000):
            return -1
        for index in range(0,self.sLength-self.p0):
            if self.sound.sample(index+self.p0) == max:
                return index+self.p0
        return 0

    def getspec(self):
    	""" Returnerer powerspectrum fra siste lydbit
    	Startpunkt bestemmes av finnmax metoden og lengden er 0.2 sekunder
    	Spekteret normaliseres og lave punkt (under -60) nulles ut"""
        pos = self.finnmax()
        if pos==-1:
            return -1
        if self.fftl>=256:
            wlen=256
        else:
            wlen=fft
        end= pos + int(0.2*self.fs) 
        spec=[]
        spec += self.sound.dBPowerSpectrum(start=pos,end=end,fftlen=self.fftl,winlen=wlen)[self.fqmin:self.fqmax]
        for n in range(self.fqmax-self.fqmin):
            if spec[n] <-60:
                spec[n] = -100
        return normalize(spec)
