# -*- coding: latin-1 -*-

import bpnn
import cPickle
from time import localtime,strftime
from os import listdir
from tkSnack import *

import Musikkmaker
import CsoundKontroll


akklist = { "null":[0,0,0,0],"d":[0,0,0,1],"e":[0,0,1,0],"f":[0,0,1,1],"g":[0,1,0,0],"a":[0,1,0,1],"h":[0,1,1,0],
        "cm":[0,1,1,1],"dm":[1,0,0,0],"em":[1,0,0,1],"fm":[1,0,1,0],"gm":[1,0,1,1],"am":[1,1,0,0],"hm":[1,1,0,1],
        "c":[1,1,1,0],"d7":[1,1,1,1]    }
midinotelist = { "null":60,"d":62,"e":64,"f":65,"g":67,"a":69,"h":71,
        "cm":60,"dm":62,"em":64,"fm":65,"gm":67,"am":69,"hm":71,
        "c":60,"d7":62    }
durlist = { "null":"dur","d":"dur","e":"dur","f":"dur","g":"dur","a":"dur","h":"dur",
        "cm":"moll","dm":"moll","em":"moll","fm":"moll","gm":"moll","am":"moll","hm":"moll",
        "c":"dur","d7":"blues"    }
soundsinit = False
pat1 = []

def normalize(list):
    """ Normaliserer listen til  inneholde verdier mellom 0 og 1
        Regner med at den bare fr bare inn negative verdier!!!
    """
    outlist = []
    if(abs(max(list))>abs(min(list))):
        print 'FEIL!!! - Fant en positiv verdi'
        oldMax = float(max(list))
    else:
        oldMax = float(abs(min(list)))
    for item in list:
        item = (item/oldMax)*-1
        outlist.append(item)
    return outlist

def finnAkk(val):
    """ Finner en akkord for gitt verdi """
    for key in akklist:
        if akklist[key]==val:
            return key
    return "fant ingen passende akkord"

def finnDur(val):
    """ Finner dur/moll for gitt verdi """
    return durlist[val]

def finnMidiN(val):
    """ Finner midinummer for gitt verdi """
    return midinotelist[val]

def finnDir(nn,dir,fft=512,fqs=0,fqe=128):
    """Tester alle akkorder i en mappe"""
    for file in listdir(dir):
        val = getAkkVals(dir+'/'+file,fft=fft,fqs=fqs,fqe=fqe)
        print file,':',finnAkk(nn.finnVal(val)),
        print '     ', 
        nn.finnValError(val)

def getAkkVals(fil,fft=512,fqs=0, fqe=128):
    """Returnerer en tuple med verdier fra PowerSpectrum"""
    ns = Sound(load=fil)
    if fft>=256:
        wlen=256
    else:
        wlen=fft
    start=findmax(ns) 
    if (ns.length()-start)<fft:
        start=ns.length()-fft
    end=start + int(0.2*ns.cget('frequency'))
    if end>ns.length():
        end = ns.length()-1
    spec = []
    spec += ns.dBPowerSpectrum(start=start,end=end,fftlength=fft,windowlength=wlen)[fqs:fqe]
    for n in range(len(spec)):
        if spec[n] <-60:
            spec[n] = -100
    return normalize(spec)

def findmax(ns):
    """Returnerer posisjonen til samplet med hyest verdi"""
    lengde = ns.length()
    max = ns.max()
    #print 'max:',max
    for index in range(0,lengde):
        if ns.sample(index) == max:
            return index
    return 0

def opprett(ni=128,nh=24, nu=4):
    """ Oppretter et nevralt nettverk med ni inn-noder, nh skjulte noder og nu ut-noder"""
    print strftime("%H:%M:%S", localtime()),': Oppretter nettverk (',ni,nh,nu,')'
    nn = bpnn.NN(ni, nh, nu)
    return nn

def tren(nn,it=1000,minerr=0.0):
    """ Trener opp nettverket. Stopper etter gitt antall iterasjoner, eller nr gitt
        minimumserror er oppndd 
    """
    if(len(pat1)<1):
        print 'Ingen opptreningsverdier i pat1'
        return
    print strftime("%H:%M:%S", localtime()),': Trener pat1... Lengde:',len(pat1)
    print it,'iterasjoner'
    nn.train(pat1,iterations=it,stoperr=minerr)
    print strftime("%H:%M:%S", localtime()),': Ferdig med trening'

def saveData(nn,fil='nntune.nnt',exI = []):
    """lagrer data til fil"""
    file = open(fil, 'w')
    data = {'nn' : nn,'pat1' : pat1, 'exI' : exI}
    cPickle.dump( data, file)
    file.close()
    print 'Lagret nettverk til', fil

def restoreData(fil='nntune.nnt'):
    """henter data fra fil"""
    file = open(fil, 'r')
    data = cPickle.load(file)
    file.close()
    #global nn,pat1
    nn = data[ 'nn']
    pat1 = data[ 'pat1']
    print 'Lastet inn nettverk fra',fil
    if data.has_key('exI'):
        return nn,data['exI']
    else:
        return nn,0

def restoreDataPat(fil='nntune.nnt'):
    """henter data fra fil"""
    file = open(fil, 'r')
    data = cPickle.load(file)
    file.close()
    global pat1
    pat1 += data[ 'pat1']
    print 'La til pat fra',fil
    print len(pat1), 'patterns'
    return pat1


def finnSaved():
    """Returnerer en liste over alle lagrede nettverk i gjeldende mappe"""
    outlist = []
    for file in listdir('./'):
        if file[-3:len(file)] == 'nnt':
            outlist.append(file)
    return outlist

